const UNIT_TEMPLATE = "units/athen_support_female_citizen";

var QuickSpawn = function(x, z, template, owner = 1)
{
	let ent = Engine.AddEntity(template);

	let cmpEntOwnership = Engine.QueryInterface(ent, IID_Ownership);
	if (cmpEntOwnership)
		cmpEntOwnership.SetOwner(owner);

	let cmpEntPosition = Engine.QueryInterface(ent, IID_Position);
	cmpEntPosition.JumpTo(x, z);
	return ent;
};

var WalkTo = function(x, z, ent, owner = 1)
{
	ProcessCommand(owner, {
		"type": "walk",
		"entities": Array.isArray(ent) ? ent : [ent],
		"x": x,
		"z": z,
		"queued": false
	});
	return ent;
};

var Do = function(name, data, ent, owner = 1)
{
	let comm = {
		"type": name,
		"entities": Array.isArray(ent) ? ent : [ent],
		"queued": false
	};
	for (let k in data)
		comm[k] = data[k];
	ProcessCommand(owner, comm);
};

var cmpTrigger = Engine.QueryInterface(SYSTEM_ENTITY, IID_Trigger);

var entities = [];

Trigger.prototype.SetupUnitsEverywhere = function()
{
	for (let x = 0; x < 32*16*4; x += 50)
		for (let z = 0; z < 32*16*4; z += 50)
			for (let owner = 1; owner <= 8; owner++)
				entities.push(QuickSpawn(x+owner, z, UNIT_TEMPLATE, owner));
};


Trigger.prototype.SetupUnitsSomeAndMove = function()
{
	for (let x = 0; x < 32*16*4; x += 50*2)
		for (let z = 0; z < 32*16*4; z += 50*2)
			for (let owner = 1; owner <= 8; owner++)
			{
				let ent = QuickSpawn(x+owner, z, UNIT_TEMPLATE, owner);
				WalkTo(x + 50 + owner, z+owner, ent, owner);
				entities.push(ent);
			}
};

Trigger.prototype.KillAll = function()
{
	for (let ent of entities)
		Engine.DestroyEntity(ent);
	entities = [];
};

cmpTrigger.DoAfterDelay(400, "SetupUnitsEverywhere", {});
cmpTrigger.DoAfterDelay(800, "KillAll", {});
cmpTrigger.DoAfterDelay(1000, "SetupUnitsSomeAndMove", {});
cmpTrigger.DoAfterDelay(10000, "KillAll", {});
